/** Le istanze di questa classe rappresentano frazioni ridotte ai minimi termini.
 * 
 * @author Paolo Boldi
 *
 */
public class Frazione {
	// ATTRIBUTI
	/** Questo &egrave; il numeratore eventualmente negativo della frazione dopo la semplificazione. */
	private int num;
	/** Questo &egrave; il denominatore positivo della frazione dopo la semplificazione. */
	private int den;
	
	// COSTRUTTORI
	/** Costruisce una frazione con i parametri dati, semplificandola.
	 * 
	 * @param x il numeratore (prima della eventuale semplificazione).
	 * @param y il denominatore (prima della eventuale semplificazione).
	 */
	public Frazione(int x, int y) {
		// ALERT handle the case y==0 correctly!
		int r = MyMath.gcd(Math.abs(x), Math.abs(y));
		num = Math.abs(x) / r;
		den = Math.abs(y) / r;
		if ((x < 0 && y > 0) || (x > 0 && y < 0))   /// if (x*y < 0) 
			num = -num;
	}
	
	public Frazione(int x) {
		this(x, 1);
	}
	
	public int getNumeratore() {
		return this.num;
	}
	
	public int getDenominatore() {
		return this.den;
	}
	
	/** Restituisce il prodotto fra la frazione su cui &egrave; invocato e quella passata come argomento.
	 * 
	 * @param f uno delle due frazioni coinvolte (l'altra &egrave; il target dell'invocazione).
	 * @return il prodotto.
	 */
	public Frazione per(Frazione f) {
		int x, y;
		x = f.num * this.num;
		y = f.den * this.den;
		Frazione ris;
		ris = new Frazione(x, y);
		return ris;
	}
	
	public boolean isNegativa() {
		return this.num < 0;
	}
	
	public boolean isZero() {
		return this.num == 0;
	}
	
	public boolean isMinore(Frazione f) {
		return this.meno(f).isNegativa();
	}
	
	
	@Override
	public String toString() {
		if (this.den > 1)
			return this.num + "/" + this.den;
		else
			return String.valueOf(this.num);
	}
	
	
	
	
	

}
